;****************************************************************************
;***                                                                      ***
;***        File Name         :  BUZZER.ASM                               ***
;***        Description       :  uU[炷                           ***
;***                                                                      ***
;****************************************************************************

include         std.inc

PIT_CTL			equ		43h						; 8253|[gAhX
PIT_CH2			equ		42h						; 8253JE^Q
SYS_B			equ		61h						; VXe|[ga

                .code

;******************************************************************************
;*                                                                            *
;*          uU[炷                                                    *
;*          void        Buzzer(int BuzzWaitValue, uint BuzzerCount);          *
;*          p[^FBuzzerWaitValue   炷 (1 = 10ms)             *
;*                      BuzzerCount       1193180/g                      *
;*          ߂lF    Ȃ                                                  *
;*                                                                            *
;******************************************************************************
Buzzer			proc	uses cx, BuzzWaitValue:word, BuzzerCount:word
				mov		al, 10110110b			; CH2,JE^LSB,MSBɃ[h
												; `gWFl[^CoCi
				out		PIT_CTL, al
				mov		ax, BuzzerCount			; 1193180/g
				out		PIT_CH2, al				; ʃoCg(LSB)̃[h
				xchg	ah, al
				out		PIT_CH2, al				; ʃoCg(MSB)̃[h

				in		al, SYS_B
				or		al, 3					; Xs[JCCH2o
				out		SYS_B, al

				mov		ax, BuzzWaitValue
				.if ax != 0
                    mov     cx, 10000           ; 1P = 10000s ɕϊ
                    mul     cx
                    mov     cx, dx              ; cx:dx  sPʂŐݒ
                    mov     dx, ax
                    INT15   86h                 ; ҂Ԍoߑ҂
				.endif

				in		al, SYS_B
				and		al, ( not 3 )			; Xs[J~CCH2~
				out		SYS_B, al
				ret
Buzzer			endp


				end
