;****************************************************************************
;***																	  ***
;***		File Name         :  CURSOR.ASM								  ***
;***		Description       :  J[\֐						  ***
;***																	  ***
;****************************************************************************

include			std.inc

                .code

;******************************************************************************
;*                                                                            *
;*          J[\`̐ݒ                                                *
;*          void       SetCursorType(int start, int endpos);                  *
;*          :      start  = Jnʒu (0-7) 20h̎A\                *
;*                     endpos = Iʒu (0-7)                                *
;*                                                                            *
;******************************************************************************
SetCursorType	proc	start:byte, endpos:byte
				mov		ch, start				; Jnʒu
				mov		cl, endpos				; Iʒu
				VIDEO	01h
				ret
SetCursorType	endp


;******************************************************************************
;*                                                                            *
;*          J[\ʒu̐ݒ                                                *
;*          void       SetCursorPos(int col, int row);                        *
;*          p[^F col ,row  J[\ʒuW                           *
;*                                                                            *
;******************************************************************************
SetCursorPos	proc	col:byte, row:byte
				mov		dh, row					; sʒu
				mov		dl, col					; ʒu
				sub		dx, 101h				; s̕␳
				xor		bh, bh					; y[Wԍ
				VIDEO	02h
				ret
SetCursorPos	endp


;******************************************************************************
;*                                                                            *
;*          J[\ʒuE`̕ۊ                                          *
;*          void       SaveCursor(void)                                       *
;*                                                                            *
;*          J[\ʒuE`̕                                          *
;*          void       RestoreCursor(void)                                    *
;*                                                                            *
;******************************************************************************
SaveCur			word	?						; J[\`ۑpϐ
SaveCurPos		word	?						; J[\ʒuۑpϐ

SaveCursor		proc
				xor     bh, bh					; y[Wԍ
				VIDEO	03h						; J[\ʒuE`̓ǂݎ
				mov		cs:SaveCur, cx
				mov		cs:SaveCurPos, dx
				ret
SaveCursor		endp

RestoreCursor	proc
				mov		cx, cs:SaveCur
				VIDEO	01h						; J[\`̐ݒ
				mov		dx, cs:SaveCurPos
				xor		bh, bh					; y[Wԍ
				VIDEO	02h						; J[\ʒu̐ݒ
				ret
RestoreCursor	endp


				end
