;****************************************************************************
;***																	  ***
;***		File Name         :  GETVMODE.ASM							  ***
;***		Description       :  Get Video Mode							  ***
;***																	  ***
;****************************************************************************

include         std.inc

bios            segment at 0
                org     0449h
CurrentVmode    byte    ?                       ; ݂̃rfI[h
TextColumn      word    ?                       ; eLXg
                org     0484h
TextLines       byte    ?                       ; eLXgs|P
FontHeight      word    ?                       ; tHg̍


                .data
_ScreenColumn   word    ?                       ; ʂ̕
_ScreenHeight   word    ?                       ; ʂ̍

                .code

;******************************************************************************
;*                                                                            *
;*          rfIE[h̎擾                                              *
;*          void       GetVideoInfo(VIDEO_INF *gvi);                          *
;*                     VIDEO_INF *gvi  rfI\                       *
;*          ߂lF     Ȃ                                                 *
;*                                                                            *
;*  bꑤ̒`                                                            *
;*                                                                            *
;*    typedef    struct {                                                     *
;*                uchar   CurrentVmode ;        // ݂̃rfI[h         *
;*                int     Column ;              //                        *
;*                char    Lines ;               // s                       *
;*                int     FontHeight ;          // tHg̍             *
;*    }VIDEO_INF ;                                                            *
;*                                                                            *
;*    static    VIDEO_INF VideoInf ;            // rfI[hi[       *
;*                                                                            *
;******************************************************************************
GetVideoInfo    proc    uses es si di, gvi:PBYTE
                if @model gt 3                  ; [Efɂ
                les     di, gvi                 ; \̱ڽZbg
                else
                mov     di, gvi                 ; \̱ڽZbg
                MOVSEG  es, ds
                endif
                push    ds
                sub     ax, ax
                mov     ds, ax
                assume  ds:bios
                mov     si, offset CurrentVmode ; ݂̃rfI[h𓾂
                lodsb                           ; rfI[h
                and     al, 7Fh                 ; ŏʃrbgItɂ
                stosb                           ; rfI[hi[
                lodsw
                stosw                           ; Ps̕
                push    ax
                mov     si,offset TextLines     ; ʂ̍s-1
                lodsb                           ; ʍs
                push    ax
                VIDEO   1D02h                   ; \s̎擾
                pop     ax
                add     ax, bx                  ; \s𑫂
                inc     ax
                stosb                           ; {̉ʍs
                movsw                           ; tHg̍
                pop     bx
                pop     ds
                assume  ds:@data
                mov     _ScreenColumn, bx       ; ϐւ̕ۑ
                mov     _ScreenHeight, ax       ; ϐւ̕ۑ
                ret
GetVideoInfo    endp


;******************************************************************************
;*                                                                            *
;*          rfIE[h̐ݒ                                              *
;*          void       SetVideoMode(int VideoMode);                           *
;*          p[^:VideoMode   ݒ肵rfIE[h                   *
;*                                                                            *
;******************************************************************************
SetVideoMode    proc    VideoMode:byte
                mov     al, VideoMode
                VIDEO   0
                ret
SetVideoMode    endp


                end
