;;===========================================================================
;;===========================================================================
;;===					MOUSE.COM Ή}EX֐					  ===
;;===											Author : T.Shibazaki	  ===
;:===											Date   : March/6/'92	  ===
;;===========================================================================
;;===========================================================================

include			std.inc

	extrn	GetVideoInfo : far

				.data

				even

VideoInfo		struc
	CurrentVmode	db		?			;; ݂̃rfI[h
	Column			dw		?			;; 
	Lines			db		?			;; s
	FontHeight		dw		?			;; tHg̍
VideoInfo		ends

vi		VideoInfo		<0,0,0,0>		;; Video Information

divcnt				dw		?			;; Font height
uf_save				dd		?			;; User Function Entry Addr.

uf_save1			dd		?			;; User Function 1 Entry Addr.
uf_save2			dd		?			;; User Function 2 Entry Addr.
uf_save3			dd		?			;; User Function 3 Entry Addr.

uf					dw		offset OrigUserFunction1
					dw		seg OrigUserFunction1
					dw		offset OrigUserFunction2
					dw		seg OrigUserFunction2
					dw		offset OrigUserFunction3
					dw		seg OrigUserFunction3

orig_uf			struc
	dummy			dw		?
	trigger			dw		?
	orig_uf_off		dw		?
	orig_uf_seg		dw		?
orig_uf			ends

orig_uf_save	orig_uf		3	dup(<?>,<?>,<?>)

work				dw		?			;; Work Area
left_b				dw		0			;; Left Button Status
right_b				dw		0			;; Right Button Status
InfoSeg				dw		-1			;; Information Area Segment

					dw		1024 dup(0)
stack_area			dw		0


				.code

ax_save				dw		?
ss_save				dw		?
sp_save				dw		?

MouseCurInfo	struc
		CurX	dw		?
		CurY	dw		?
		Button	db		2	dup(?)
MouseCurInfo	ends

SetVideoInfo		proto	near
OrigUserFunction	proto	private

;;===========================================================================
;;		Description : }EX̏ݒ
;;		Sequence 	: unsigned	GetMouseState(void) ;
;;		߂l      : struct {
;;							usnigned State :8 ;@EEEOFgps@PFgp\
;;							unsigned BotCnt:8 ;@EEE}EX{^̐
;;					  } ;
;;===========================================================================
GetMouseState		proc
					call	SetVideoInfo
					MOUSE	0,0
					xchg	ah,bl
					ret
GetMouseState		endp

;;===========================================================================
;;		Description : }EXJ[\̂nm^nee
;;		Sequence 	: void	CtrlMouseCursor(int  sw) ;
;;		p[^  : int	sw ; EEEOFnee@@PFnm
;;		߂l      : void
;;===========================================================================
CtrlMouseCursor		proc	sw:word
					mov		ax,sw
					inc		ax
					MOUSE
					ret
CtrlMouseCursor		endp

;;===========================================================================
;;		Description : }EXJ[\ʒuƃ{^Ԃ̓ǂݎ
;;		Sequence 	: void	GetMouseCursorInfo(struct  MouseCurInfo  *mc) ;
;;		p[^  : struct MouseCursorInfo   *mc ;
;;		߂l      : struct MouseCursorInfo   *mc ;
;;===========================================================================
GetMouseCursorInfo	proc	uses	bx cx dx es di,mc:PBYTE

					MOUSE	0,3

					if	@model gt 3
						les		di,[mc]
					else
						mov		di,[mc]
						MOVSEG	es,ds
					endif

					mov		ax,cx					;; X WZbg
					add		ax,[divcnt]
					dec		ax						;; ۂ
					mov		cl,byte ptr [divcnt]
					div		cl
					xor		ah,ah					;; ]
					inc		ax
					stosw

					mov		ax,dx					;; Y WZbg
					add		ax,[divcnt]
					dec		ax						;; ۂ
					mov		cx,[divcnt] 			;;
					div		cl
					xor		ah,ah					;; ]
					inc		ax
					stosw

					mov		ax,bx					;; {^
					and		ax,1
					stosb
					mov		ax,bx					;; E{^
					shr		ax,1
					and		ax,1
					stosb

					ret
GetMouseCursorInfo	endp

;;===========================================================================
;;				rfIɂOtBbNX^eLXg䗦
;;===========================================================================
SetVideoInfo		proc	near	private uses ax

					push	ds
					mov		ax,offset vi
					push	ax
					call	GetVideoInfo
					add		sp,4

					;;	[hWR܂́AORORɕϊ
					mov		al,vi.CurrentVmode
					and		al,(not 80h)

					mov		divcnt,1				;; for Graphics

					.if ( al == 3 || ( al >= 70h && al <= 73h ) )
						mov		divcnt,8			;; for Text
					.endif

					ret
SetVideoInfo		endp

;;===========================================================================
;;		Description : }EXJ[\ʒuݒ
;;		Sequence 	: void	SetMouseCursorPos(int  x,int  y) ;
;;		p[^  : int   x, y ; EEEEݒ肷J[\ʒu
;;		߂l      : void
;;===========================================================================
SetMouseCursorPos	proc	uses	cx dx , x:word , y:word

					mov		bx,[divcnt]
					mov		ax,[x]
					dec		ax
					mul		bl
					mov		cx,ax		;; ZbgJ[\wW

					mov		bx,[divcnt]
					mov		ax,[y]
					dec		ax
					mul		bl
					mov		dx,ax		;; ZbgJ[\xW

					MOUSE	0,4

					ret
SetMouseCursorPos	endp

;;===========================================================================
;;		Description : }EXNbNꂽ񐔂Ԃ
;;		Sequence 	: int	GetMouseClickCount(int  b,M_CURSOR_INFO  *mcinf) ;
;;		p[^  : int	b ; EEEEׂ{^wB0:  1:E
;;					  M_CURSOR_INFO  *mcinf; ݂̃{^̏ԂƁA{^
;;											 ꂽƂ̍WB
;;		߂l      : w肵{^̉ꂽ
;;===========================================================================
GetMouseClickCount	proc	uses	bx cx dx , btn:word , mc:PBYTE
					mov		bx,[btn]
					MOUSE	0,5

					if	@model gt 3
						les		di,[mc]
					else
						mov		di,[mc]
						MOVSEG	es,ds
					endif

					push	ax

					mov		ax,cx			;; X WZbg
					add		ax,[divcnt]
					dec		ax				;; ۂ
					mov		cl,byte ptr [divcnt]
					div		cl
					xor		ah,ah			;; ]
					inc		ax
					stosw

					mov		ax,dx			;; Y WZbg
					add		ax,[divcnt]
					dec		ax
					mov		cx,[divcnt]
					div		cl
					xor		ah,ah			;; ]
					inc		ax
					stosw
					pop		ax

					mov		cx,ax			;; ݂̍E{^
					and		ax,1
					stosb
					mov		ax,cx
					shr		ax,1
					and		ax,1
					stosb

					mov		ax,bx
					ret
GetMouseClickCount	endp

;;===========================================================================
;;		Description : }EX{^ꂽ񐔂Ԃ
;;		Sequence 	: int	GetMouseReleaseCount(int  b,M_CURSOR_INFO  *mcinf) ;
;;		p[^  : int	b ; EEEEׂ{^wB0:  1:E
;;					  M_CURSOR_INFO  *mcinf; ݂̃{^̏ԂƁA{^
;;											 ꂽƂ̍WB
;;		߂l      : w肵{^̗ꂽ
;;===========================================================================
GetMouseReleaseCount	proc	uses	bx cx dx , btn:word , mc:PBYTE
					mov		bx,[btn]
					MOUSE	0,6

					if	@model gt 3
						les		di,[mc]
					else
						mov		di,[mc]
						MOVSEG	es,ds
					endif

					push	ax

					mov		ax,cx			;; X WZbg
					add		ax,[divcnt]
					dec		ax
					mov		cl,byte ptr [divcnt]
					div		cl
					xor		ah,ah					;; ]
					inc		ax
					stosw

					mov		ax,dx			;; Y WZbg
					add		ax,[divcnt]
					dec		ax
					mov		cx,[divcnt]
					div		cl
					xor		ah,ah					;; ]
					inc		ax
					stosw
					pop		ax

					mov		cx,ax			;; ݂̍E{^
					and		ax,1
					stosb
					mov		ax,cx
					shr		ax,1
					and		ax,1
					stosb

					mov		ax,bx
					ret
GetMouseReleaseCount	endp

;;===========================================================================
;;		Description : }EẌړ͈͐ݒ
;;		Sequence 	: void	SetMousePhysBlock(int x1,int y1,int x2,int y2) ;
;;		p[^  : int	x1 , y1 ; EEEړ͈͂̍ŏl
;;					  int	x2 , y2 ; EEEړ͈͂̍ől
;;		߂l      : void
;;===========================================================================
SetMousePhysBlock	proc	uses bx cx dx , x1:word ,y1:word ,x2:word,y2:word

					mov		ax,[x2]
					dec		ax
					mov		cx,[divcnt]
					mul		cl
					mov		dx,ax

					mov		ax,[x1]
					dec		ax
					mov		cx,[divcnt]
					mul		cl
					mov		cx,ax
					MOUSE	0,7

					mov		ax,[y2]
					dec		ax
					mov		cx,[divcnt]
					mul		cl
					mov		dx,ax

					mov		ax,[y1]
					dec		ax
					mov		cx,[divcnt]
					mul		cl
					mov		cx,ax

					MOUSE	0,8

					ret
SetMousePhysBlock	endp

;;===========================================================================
;;		Description : OtBbNJ[\̒`
;;		Sequence 	: void	SetMouseCursorShape(int xpoint,int ypoint,char *ship) ;
;;		p[^  : int	xpoint ; EEEJ[\w_w
;;					  int	ypoint ; EEEJ[\w_x
;;					  char	*ship ;  EEEJ[\rbg}bv
;;										 0:ĳ  1:ʰ޳
;;		߂l      : void
;;===========================================================================
SetMouseCursorShape	proc	uses	bx cx dx , 	\
									xpoint:word , ypoint:word , ship:PBYTE

					mov		bx,[xpoint]
					mov		cx,[ypoint]
					les		dx,[ship]
					MOUSE	0,9

					ret
SetMouseCursorShape	endp

;;===========================================================================
;;		Description : eLXgJ[\̐ݒ
;;		Sequence 	: void	SetMouseCursorMode(mode,and_mask,xor_mask) ;
;;		p[^  : int	mode ; EEEeLXgJ[\[h
;;										 0:ĳ  1:ʰ޳
;;					  unsigned and_mask ; EEEAND }XNl
;;					  unsigned and_mask ; EEEXOR }XNl
;;		߂l      : void
;;===========================================================================
SetMouseCursorMode	proc	uses bx cx dx , cur_mode:word , and_mask:word , xor_mask:word

					mov		bx,[cur_mode]
					mov		cx,[and_mask]
					mov		dx,[xor_mask]
					MOUSE	0,10

					ret
SetMouseCursorMode	endp

;;===========================================================================
;;		Description : }EẌړ̓ǂݎ
;;		Sequence 	: void	GetMouseMoveDis(int  *xdis,int  *ydis) ;
;;		p[^  : int	*xdis ; EEEw̃̐
;;					  int	*ydis ; EEEx̃̐
;;		߂l      : void
;;===========================================================================
GetMouseMoveDis		proc	uses bx cx dx es di, xdis:PBYTE , ydis:PBYTE

					MOUSE	0,11
					if @model gt 3
                        les		di,[xdis]
                    else
                        mov     di,[xdis]
                    endif
					mov		ax,cx
					stosw

                    if @model gt 3
    					les		di,[ydis]
                    else
                        mov     di,[ydis]
                    endif
					mov		ax,dx
					stosw

					ret
GetMouseMoveDis		endp

;;===========================================================================
;;		Description : }EXgK[A[U荞
;;		Sequence 	: void	SetMouseUserInt(unsigned flag,int  (*func)()) ;
;;		p[^  : unsigned   flag ; EEEgK[tO
;;					  int	(*func)() ; EEE荞݃vO
;;		߂l      : void
;;===========================================================================
SetMouseUserInt		proc	uses bx cx dx es , \
											trig_flag:word , user_func:PBYTE

					;;	[U֐AhXҔ
					les		dx,[user_func]
					mov		word ptr uf_save,dx
					mov		word ptr uf_save[2],es

					;;	gK[Zbg
					mov		cx,[trig_flag]
					mov		ax,seg	OrigUserFunction
					mov		es,ax
					mov		dx,offset OrigUserFunction
					MOUSE	0,12

					ret
SetMouseUserInt		endp

;;===========================================================================
;;		Description : }EXgK[AIWi[U荞
;;===========================================================================
OrigUserFunction	proc	private uses	ax bx cx dx ds si es di

					mov		cs:ax_save,ax

					mov		ax,@data
					mov		ds,ax				;; DS 𕜌

					assume	ds:@data

					mov		cs:ss_save,ss		;; hCorrҔ
					mov		cs:sp_save,sp		;; hCoroҔ

					cli
					mov		ss,ax				;; DS = SS ɐݒ
					mov		sp,offset stack_area
					sti

					dec		ax
					mov		es,ax				;; ES ݒ

					call	CommonOrigUser

					push	di
					push	si
					push	dx
					push	cx
					push	right_b
					push	left_b
					push	ax
					call	[uf_save]
					add		sp,14

					cli
					mov		ax,cs:ss_save
					mov		ss,ax
					mov		ax,cs:sp_save
					mov		sp,ax
					sti

					ret
OrigUserFunction	endp

;;===========================================================================
;;		Description : CgEyEG~[VJnEI
;;		Sequence 	: void	WritePenEmulation(int  sw) ;
;;		p[^  : int	sw ; EEEE0:Jn@@1:I
;;		߂l      : void
;;===========================================================================
WritePenEmulation   proc    uses    ax , sw:word
                    mov     ax,13
                    add     ax,[sw]
                    MOUSE
                    ret
WritePenEmulation   endp

;;===========================================================================
;;		Description : }EẌړ䗦̐ݒ
;;		Sequence 	: void	SetMouseDistance(inr  xdis,int  ydis) ;
;;		p[^  : int	xdis ; EEEEw̃}EX̐(1`32767)
;;					  int	ydis ; EEEEx̃}EX̐(1`32767)
;;		߂l      : void
;;===========================================================================
SetMouseDistance	proc	uses	bx cx dx , xdis:word , ydis:word
					mov		cx,[xdis]
					mov		dx,[ydis]
					MOUSE	0,15
					ret
SetMouseDistance	endp

;;===========================================================================
;;		Description : J[\͈͂̐ݒ
;;		Sequence 	: void	SetMouseClearRange(int x1,int y1,int x2,int y2) ;
;;		p[^  : int	x1 , y1 ; EEEE͈͍̍Wl
;;					  int	x2 , y2 ; EEEE͈͉E̍Wl
;;		߂l      : void
;;===========================================================================
SetMouseClearRange	proc	uses	cx dx si di , \
									x1:word , y1:word , x2:word , y2:word

					mov		ax,[y2]
					mov		cx,[divcnt]
					mul		cl
					mov		di,ax

					mov		ax,[x2]
					mov		cx,[divcnt]
					mul		cl
					mov		si,ax

					mov		ax,[y1]
					mov		cx,[divcnt]
					mul		cl
					mov		dx,ax

					mov		ax,[x1]
					mov		cx,[divcnt]
					mul		cl
					mov		cx,ax

					MOUSE	0,16

					ret
SetMouseClearRange	endp

;;===========================================================================
;;		Description : {El̐ݒ
;;		Sequence 	: void	SetMouseOverDrive(int  OVcnt) ;
;;		p[^  : int	OVcnt ; EEE{El
;;		߂l      : void
;;===========================================================================
SetMouseOverDrive	proc	uses	dx , OVcnt:word
					mov		dx,[OVcnt]
					MOUSE	0,19
					ret
SetMouseOverDrive	endp

;;===========================================================================
;;		Description : [U荞݂̃}XNƊ荞݃[`̌
;;		Sequence 	: void	ResetMouseUserInt(unsigned flag,int  (*func)()) ;
;;		p[^  : unsigned	flag ; EEEgK[tO
;;					  int	(*func)() ;EEE[U荞݃[`
;;		߂l      : void
;;===========================================================================
ResetMouseUserInt	proc	uses	es dx cx ,trig_flag:word , user_func:PBYTE

					;;	[U֐AhXҔ
					les		dx,[user_func]
					mov		word ptr uf_save,dx
					mov		word ptr uf_save[2],es

					;;	gK[Zbg
					mov		cx,[trig_flag]
					mov		ax,seg	OrigUserFunction
					mov		es,ax
					mov		dx,offset OrigUserFunction
					MOUSE	0,20

					ret
ResetMouseUserInt	endp

;;===========================================================================
;;		Description : }EXhCȍԕۑ
;;		Sequence 	: int	SaveMouseInfo(void) ;
;;		p[^  : void
;;		߂l      :  0: Normal End
;;					  -1: Not enough memory
;;===========================================================================
SaveMouseInfo		proc	uses	bx dx es

					MOUSE	0,21			;; ԕۑpɕKvȃobt@TCY

					add		bx,15
					shr		bx,1
					shr		bx,1
					shr		bx,1
					shr		bx,1

					MSDOS		48h			;; L̊蓖

					.if !carry?				;; I?
						mov		[InfoSeg],ax;; ZOgۑ
						mov		es,ax		;; ۑobt@AhXݒ
						xor		dx,dx		;; ItZbgݒ
						MOUSE	0,22
						xor		ax,ax		;; ߂lO
					.else
						mov		ax,-1			;; ߂l|P
					.endif

					ret
SaveMouseInfo		endp

;;===========================================================================
;;		Description : }EXhCȍԕA
;;		Sequence 	: void	RestoreMouseInfo(void) ;
;;		p[^  : void
;;		߂l      :  0: Normal End
;;					  -1: Anallocated memory
;;===========================================================================
RestoreMouseInfo	proc	uses	dx es

					mov		ax,-1

					.if [InfoSeg] != -1
						mov		es,[InfoSeg]		;; Mouse Info. buffer
						xor		dx,dx				;;	address set
						MOUSE	0,23

						MSDOS	49h					;; Release Allocate Block

						xor		ax,ax				;; InfoSeg reset to -1
						dec		ax
						mov		[InfoSeg],ax
						inc		ax
					.endif

					ret
RestoreMouseInfo	endp

;;===========================================================================
;;		Description : ֊荞݃[`̐ݒ
;;		Sequence 	: void	SetExtMouseUserInt(unsigned flag,int  (*func)()) ;
;;		p[^  : unsigned	flag ; EEEgK[tO
;;					  int	(*func)() ;EEE[U荞݃[`
;;					  int	user_no ;  EEE[UԍiO`Qj
;;		߂l      : void
;;===========================================================================
SetExtMouseUserInt	proc	uses	bx cx dx es di , trig_flag:word , user_func:PBYTE , user_no:word

					;;	֊荞݃AhX̕ۊ
					mov		cx,[trig_flag]
					MOUSE	0,25

					mov		ax,cx				;; cx Ҕ

					mov		cx,[user_no]
					shl		cx,1
					shl		cx,1
					shl		cx,1				;; user_no * 8

					;;	ݐݒ肳ĂgK[ɑ΂銄荞݂ۊ
					mov		di,offset [orig_uf_save]
					add		di,cx
					mov		(orig_uf ptr [di]).trigger,ax
					mov		(orig_uf ptr [di]).orig_uf_off,dx
					mov		(orig_uf ptr [di]).orig_uf_seg,bx

					mov		cx,[user_no]
					shl		cx,1
					shl		cx,1				;; user_no * 4

					;;	[U荞݃AhX̑Ҕ
					les		dx,[user_func]
					mov		di,offset [uf_save1]
					add		di,cx
					mov		[di],dx
					mov		[di+2],es

					;;	[U荞݂̐ݒ
					mov		di,offset [uf]
					add		di,cx
					mov		dx,[di]
					mov		ax,[di+2]
					mov		es,ax

					;;	荞݃gK[ݒ
					mov		cx,[trig_flag]
					MOUSE	0,24

					ret
SetExtMouseUserInt	endp

;;===========================================================================
;;		Description : }EXgK[AIWi[U荞
;;===========================================================================
OrigUserFunction1	proc	private uses	ax bx cx dx ds si es di

					mov		cs:ax_save,ax

					mov		ax,@data
					mov		ds,ax				;; DS 𕜌

					assume	ds:@data

					mov		cs:ss_save,ss		;; hCorrҔ
					mov		cs:sp_save,sp		;; hCoroҔ

					cli
					mov		ss,ax				;; DS = SS ɐݒ
					mov		sp,offset stack_area
					sti

					dec		ax
					mov		es,ax				;; ES ݒ

					call	CommonOrigUser

					push	di
					push	si
					push	dx
					push	cx
					push	right_b
					push	left_b
					push	ax
					call	[uf_save1]
					add		sp,14

					cli
					mov		ax,cs:ss_save
					mov		ss,ax
					mov		ax,cs:sp_save
					mov		sp,ax
					sti

					ret
OrigUserFunction1	endp

;;===========================================================================
;;		Description : }EXgK[AIWi[U荞
;;===========================================================================
OrigUserFunction2	proc	private uses	ax bx cx dx ds si es di

					mov		cs:ax_save,ax

					mov		ax,@data
					mov		ds,ax				;; DS 𕜌

					assume	ds:@data

					mov		cs:ss_save,ss		;; hCorrҔ
					mov		cs:sp_save,sp		;; hCoroҔ

					cli
					mov		ss,ax				;; DS = SS ɐݒ
					mov		sp,offset stack_area
					sti

					dec		ax
					mov		es,ax				;; ES ݒ

					call	CommonOrigUser

					push	di
					push	si
					push	dx
					push	cx
					push	right_b
					push	left_b
					push	ax
					call	[uf_save2]
					add		sp,14

					cli
					mov		ax,cs:ss_save
					mov		ss,ax
					mov		ax,cs:sp_save
					mov		sp,ax
					sti

					ret
OrigUserFunction2	endp

;;===========================================================================
;;		Description : }EXgK[AIWi[U荞
;;===========================================================================
OrigUserFunction3	proc	private uses	ax bx cx dx ds si es di

					mov		cs:ax_save,ax

					mov		ax,@data
					mov		ds,ax				;; DS 𕜌

					assume	ds:@data

					mov		cs:ss_save,ss		;; hCorrҔ
					mov		cs:sp_save,sp		;; hCoroҔ

					cli
					mov		ss,ax				;; DS = SS ɐݒ
					mov		sp,offset stack_area
					sti

					dec		ax
					mov		es,ax				;; ES ݒ

					call	CommonOrigUser

					push	di
					push	si
					push	dx
					push	cx
					push	right_b
					push	left_b
					push	ax
					call	[uf_save3]
					add		sp,14

					cli
					mov		ax,cs:ss_save
					mov		ss,ax
					mov		ax,cs:sp_save
					mov		sp,ax
					sti

					ret
OrigUserFunction3	endp

;;===========================================================================
;;		Description : IWiE[U荞݋ʕ
;;===========================================================================
CommonOrigUser		proc	near

					mov		ax,cs:ax_save

					push	ax

					push	cx
					mov		ax,dx				;; Y WZbg
					add		ax,[divcnt]
					dec		ax
					mov		cx,[divcnt]
					div		cl
					xor		ah,ah					;; ]
					inc		ax
					mov		dx,ax
					pop		cx

					mov		ax,cx				;; X WZbg
					add		ax,[divcnt]
					dec		ax
					mov		cx,[divcnt]
					div		cl
					xor		ah,ah					;; ]
					inc		ax
					mov		cx,ax

					xor		ax,ax
					rcr		bx,1
					adc		al,0
					mov		left_b,ax

					xor		ax,ax
					rcr		bx,1
					adc		al,0
					mov		right_b,ax

					pop		ax

					ret
CommonOrigUser		endp

;;===========================================================================
;;		Description : ֊荞݃[`̕
;;		Sequence 	: void  ReleaseExtMouseUserInt(int  UserNo) ;
;;		p[^  : int	user_no ;  EEE[UԍiO`Qj
;;		߂l      : void
;;===========================================================================
ReleaseExtMouseUserInt		proc	uses	bx cx dx , user_no:word
					mov		cx,[user_no]
					shl		cx,1
					shl		cx,1
					shl		cx,1				;; user_no * 8
					mov		di,offset [orig_uf_save]
					add		di,cx
					mov		cx,(orig_uf ptr [di]).trigger
					mov		dx,(orig_uf ptr [di]).orig_uf_off
					mov		es,(orig_uf ptr [di]).orig_uf_seg
					MOUSE	0,24
					ret
ReleaseExtMouseUserInt		endp

;;===========================================================================
;;		Description : ֊荞݃[`̃AhX擾
;;		Sequence 	: void	*GetExtUserIntAdr(unsigned flag) ;
;;		p[^  : unsigned	flag ; EEEgK[tO
;;		߂l      : void	*UserFuncAdr EEE[U荞݃AhX
;;===========================================================================
GetExtUserIntAdr	proc	uses	bx cx dx es , trig_flag:word

					mov		cx,[trig_flag]
					MOUSE	0,25

					ret
GetExtUserIntAdr	endp

;;===========================================================================
;;		Description : }EXx̐ݒ
;;		Sequence 	: void	SetMouseCoefficient(int xcoef,int ycoef,int ovcoef) ;
;;		p[^  : int	xcoef ; EEEwړ䗦̌W(1-100)
;;					  int	ycoef ; EEExړ䗦̌W(1-100)
;;					  int	ovcoef ;EEE{EľW(1-100)
;;		߂l      : void
;;===========================================================================
SetMouseCoefficient	proc	uses	bx cx dx ,		\
										xcoef:word , ycoef:word , ovcoef:word

					mov		bx,[xcoef]
					mov		cx,[ycoef]
					mov		dx,[ovcoef]
					MOUSE	0,26

					ret
SetMouseCoefficient	endp

;;===========================================================================
;;		Description : }EXx̎擾
;;		Sequence 	:
;;			void	GetMouseCoefficient(int *xcoef,int *ycoef,int *ovcoef) ;
;;		p[^  : int	*xcoef ; EEEwړ䗦̌W(1-100)
;;					  int	*ycoef ; EEExړ䗦̌W(1-100)
;;					  int	*ovcoef ;EEE{EľW(1-100)
;;		߂l      : void
;;===========================================================================
GetMouseCoefficient	proc	uses	bx cx dx es di ,		\
										xcoef:PBYTE , ycoef:PBYTE , ovcoef:PBYTE

					MOUSE	0,26

					if @model gt 3
                        les		di,[xcoef]
                    else
                        assume  ds:@data
                        mov     di,[xcoef]
                    endif
					mov		ax,bx
					stosw

                    if @model gt 3
    					les		di,[ycoef]
                    else
                        mov     di,[ycoef]
                    endif
					mov		ax,cx
					stosw

                    if @model gt 3
    					les		di,[ovcoef]
                    else
                        mov     di,[ovcoef]
                    endif
					mov		ax,dx
					stosw

					ret
GetMouseCoefficient	endp

;;===========================================================================
;;		Description : bqsy[Wԍ̐ݒ
;;		Sequence 	: void	SetMouseCrtPage(int  crt_page) ;
;;		p[^  : int	crt_page ; EEEJ[\\bqsy[W
;;		߂l      : void
;;===========================================================================
SetMouseCrtPage		proc	uses	bx , crt_page:word

					mov		bx,[crt_page]
					MOUSE	0,29

					ret
SetMouseCrtPage		endp

;;===========================================================================
;;		Description : bqsy[Wԍ̎擾
;;		Sequence 	: int	GetMouseCrtPage(void) ;
;;		p[^  : void
;;		߂l      : int	crt_page ; EEEJ[\\bqsy[W
;;===========================================================================
GetMouseCrtPage		proc	uses	bx , crt_page:word

					MOUSE	0,30
					mov		ax,bx

					ret
GetMouseCrtPage		endp

;;===========================================================================
;;		Description : }EXhCõ̏
;;		Sequence 	: int	ReleaseMouseDriver(void) ;
;;		p[^  : void
;;		߂l      : 0: Normal End
;;					 -1: Abnormal End
;;===========================================================================
ReleaseMouseDriver	proc	uses	bx cx

					mov		bx,word ptr [33h*4]
					mov		cx,word ptr [33h*4][2]
					MOUSE	0,31

					ret
ReleaseMouseDriver	endp

;;===========================================================================
;;		Description : }EXhCõւ̍Đݒ
;;		Sequence 	: void	ResetMouseDriver(void) ;
;;		p[^  : void
;;		߂l      : void
;;===========================================================================
ResetMouseDriver	proc
					MOUSE	0,32
					ret
ResetMouseDriver	endp

;;===========================================================================
;;		Description : \tgEFAZbg
;;		Sequence 	: int	SoftResetMouse(void) ;
;;		p[^  : void
;;		߂l      : 0: }EXhCogp\
;;					 -1: }EXhCogps
;;===========================================================================
SoftResetMouse		proc
					MOUSE	0,33
					ret
SoftResetMouse		endp


					end
