;****************************************************************************
;***																	  ***
;***		File Name         :  SCROLL.ASM								  ***
;***		Description       :  Scroll									  ***
;***																	  ***
;****************************************************************************

include			std.inc

                .code

;******************************************************************************
;*                                                                            *
;*          zuq`lf[^EXN[                            *
;*          void       ScrollUp(int x1, int y1, int x2, int y2, int line);    *
;*          :      x1   = ㌅ʒu                                      *
;*                     y1   = sʒu                                      *
;*                     x2   = Eʒu                                      *
;*                     y2   = Esʒu                                      *
;*                     line = XN[s                                  *
;*                                                                            *
;******************************************************************************
ScrollUp		proc	uses ds es si di, x1:word, y1:word, x2:word, y2:word, 
										  line:word
				assume	ds:@data
				mov		ax, y1					; s
				mov		bx, x1					; 
				call	_CalcVramAddr			; zVRAMAhX̌vZ
				mov		si,di
				mov		ax, _ScreenColumn		; Ps̕
				shl		ax,1					; Ps̃oCg
				push	ax
				mov		cx, line				; XN[s
				mul		cx
				add		si,ax					; XN[O|C^[
				pop		ax
				mov		dx, x2
				sub		dx, x1
				inc		dx						; dx = XN[
				mov		cx, y2					; Is
				sub		cx, y1					; Jns
				sub		cx, line				; XN[s炷
				inc		cx						; cx = XN[s
				MOVSEG	ds,es
				.repeat							; sɕ
					PUSHM	<cx,di,si>
					mov		cx,dx				; XN[oCg
					rep		movsw				; PsXN[
					POPM	<si,di,cx>
					add		si,ax				; Ps̃oCg𑫂
					add		di,ax
				.untilcxz
				ret
ScrollUp		endp


;******************************************************************************
;*                                                                            *
;*          zuq`lf[^EXN[                            *
;*          void       ScrollUpBios(int x1, int y1, int x2, int y2,           *
;*                                  int line, int attr);                      *
;*          :      x1   = ㌅ʒu                                      *
;*                     y1   = sʒu                                      *
;*                     x2   = Eʒu                                      *
;*                     y2   = Esʒu                                      *
;*                     line = XN[s                                  *
;*                     attr = XN[̋󔒍s̑                      *
;*                                                                            *
;******************************************************************************
ScrollUpBios	proc	uses bx cx dx, x1:byte, y1:byte, x2:byte, y2:byte,
									   line:byte, attr:byte
				mov		ch, y1					; s
				mov		cl, x1					; 
				sub		cx,101h					; s
				mov		dh, y2                  ; s
				mov		dl, x2					; 
				sub		dx,101h					; s
				mov		al, line				; XN[s
				mov		bh, attr				; XN[̋󔒍s̑
				VIDEO	06h
				ret
ScrollUpBios	endp


				end
