;****************************************************************************
;***																	  ***
;***		File Name         :  DRIVE.ASM								  ***
;***		Description       :  hCu֐						  ***
;***																	  ***
;****************************************************************************

include         std.inc


WORK_SEG		segment	byte	at	0040h
				org		0010h
IoBlockArea		label	byte
WORK_SEG		ends

BIOS_WORK		segment	byte	at	0050h
				org		0004h
SelectDrive		label	byte
BIOS_WORK		ends

				.data

SingleDriveFlag		db		?					; Single Drive Flag
DriveConnectTable	db		26 dup (0)


				.code

;******************************************************************************
;*                                                                            *
;*			hCuڑ󋵂̎擾											  *
;*			int         CheckEfficiencyDrive(DrvNo) ;						  *
;*			p[^Fint   DrvNo ; --- hCuԍ						  *
;*			߁@@lF@ 0  --- YhCuڑ						  *
;*				  		  -1  --- YhCuڑ						  *
;*                                                                            *
;******************************************************************************
CheckEfficiencyDrive	proc	uses bx, drive:word

				mov		bl, byte ptr [drive]
				MSDOS	4408h
				mov		ax,0000h

				.if carry?
					dec	ax
				.endif

				ret
CheckEfficiencyDrive	endp

;******************************************************************************
;*                                                                            *
;*			foCXp[^ubN擾									  *
;*			int         GetDPB(DrvNo, DevInf);								  *
;*			p[^Fint   DrvNo     hCuԍ						  *
;*						struct DEVICE_INF  *DevInf ;						  *
;*			߁@@lF 0  --- YhCuڑ						  *
;*						-1  --- YhCuڑ						  *
;*                                                                            *
;******************************************************************************
GetDPB			proc	uses bx cx ds dx , drive:word , ParamaterBlock:PBYTE
				mov		bl, byte ptr drive
				mov		ch, 08h
				mov		cl, 60h
				lds		dx, ParamaterBlock
				MSDOS	440dh
				ret
GetDPB			endp

;******************************************************************************
;*                                                                            *
;*			hCuceʎ擾											  *
;*          ulong       GetDiskRemain(int DrvNo);							  *
;*			p[^Fint   DrvNo hCuԍ							  *
;*		    ߁@@lF      0<=   cfBXNe						  *
;*							  -1    YhCuڑ					  *
;*                                                                            *
;******************************************************************************
GetDiskRemain	proc	uses cx dx , drive:word
				mov		dx, drive
				MSDOS	36h
				mov		dx , -1
				.if ax != -1
					mul		cx
					mul		bx
					mov		bx,ax
					mov		ax,dx
				.endif
				ret
GetDiskRemain	endp

;******************************************************************************
;*                                                                            *
;*          VOhCu`FbN                                          *
;*          void        CheckSingleDrive(void) ;                              *
;*          p[^FȂ                                                  *
;*          ߁@@lFȂ                                                  *
;*                                                                            *
;******************************************************************************
CheckSingleDrive    proc    uses bx cx ds si di
                push    ds
                ; BIOS [NGA(0040H:0010H)PoCg[h
                mov     ax,WORK_SEG
                mov     ds,ax
                assume  ds:WORK_SEG
                mov     si,offset ds:IoBlockArea
                lodsb
                pop     ds

                assume  ds:@data

                mov     [SingleDriveFlag],0     ; SingleDriveFlag  OFF

                ;    PhCuVXeǂ`FbN
                .if ( al & 01h )
                    mov     cl,6
                    shr     al,cl
                    .if al == 0
                        inc     al
                        mov     [SingleDriveFlag],al    ; SingleDriveFlag  ON
                    .endif
                .endif

                .if [SingleDriveFlag] != 0

                    ; ڑhCuǗe[u
                    mov     cx,26
                    push    ds
                    pop     es
                    mov     di,offset [DriveConnectTable]
                    push    di
                    xor     ax,ax
                    rep     stosb
                    pop     si

                    xor     di,di
                    mov     cx,26

                    ; ڑhCuǗe[uݒ
                    .repeat
                        mov     bx,di           ; hCuԍZbg
                        MSDOS   4408h           ; DOS 4408H ̧ݸݔs
                        .if !carry?             ; YhCuڑL
                            mov     al,1
                            push    di
                            add     di,si
                            stosb               ; ڑ 01h Zbg
                            pop     di
                        .endif
                        inc     di
                    .untilcxz
                .endif

                ret
CheckSingleDrive    endp

;******************************************************************************
;*                                                                            *
;*          fBXPbgZbg                                            *
;*          void        SetDiskette(const uchar *AccessFile);                 *
;*          p[^Fuchar *AccessFile ANZXt@C                  *
;*          ߁@@lFȂ                                                  *
;*                                                                            *
;******************************************************************************
SetDiskette     proc    uses    bx ds si es di , AccessFile:PBYTE
                assume  ds:@data
                .if [SingleDriveFlag] != 0
                    push    ds
                    if @model gt 3
                    lds     si, AccessFile
                    else
                    mov     si, AccessFile
                    endif
                    lodsb
                    mov     bl, al              ; Save Drive Number
                    lodsb
                    pop     ds

                    .if al != ':'               ; Drive Delimit
                        MSDOS   19h             ; Get Current Drive
                        mov     bl, al          ; Save Drive Number
                    .endif

                ; ANZX̃hCuԍ擾
                ; hCue[uAwhCuڑĂ
                ; ̃hCuԍahnr[NGAɃZbgĂ܂B

                    xor     bh, bh
                    or      bl, 20h             ; Drive tolower
                    sub     bl, 61h             ; Change Numeric
                    mov     si, offset [DriveConnectTable]

                    .if byte ptr [si+bx] == 01h
                        mov     ax, BIOS_WORK
                        mov     es, ax
                        assume  es: BIOS_WORK
                        mov     di, offset [SelectDrive]
                        mov     al, bl
                        stosb
                    .endif
                .endif

                ret
SetDiskette    endp


               end
