;****************************************************************************
;***                                                                      ***
;***        File Name         :  SIGCTL.ASM                               ***
;***        Description       :  M̐ݒ肨я󋵂̎擾             ***
;***                                                                      ***
;****************************************************************************


include         std.inc
include         rsdrv.inc

                .data
                extrn   PortBase:word           ; RS-232C {I/O|[gAhX

                .code

;******************************************************************************
;*                                                                            *
;*          ER/RSM̐ݒƏԂ̎擾                                       *
;*          void         SetErOn(void);    ERMIɂ                 *
;*          void         SetErOff(void);   ERMItɂ                 *
;*          void         ChackEr(void);    ERM̏Ԃ̎擾                 *
;*          void         SetRsOn(void);    RSMIɂ                 *
;*          void         SetRsOff(void);   RSMItɂ                 *
;*          void         ChackRs(void);    RSM̏Ԃ̎擾                 *
;*                                                                            *
;******************************************************************************
SetErOn         proc   uses bx dx
                call   GetMcrStatus             ; f䃌WX^̓ǂݎ
                or     al, DTR                  ; Bit 0Iɂ܂
                out    dx, al                   ; f䃌WX^̐ݒ
                ret
SetErOn         endp

SetErOff        proc   uses bx dx
                call   GetMcrStatus             ; f䃌WX^̓ǂݎ
                and    al, not DTR              ; Bit 0Itɂ܂
                out    dx, al                   ; f䃌WX^̐ݒ
                ret
SetErOff        endp

CheckEr         proc   uses bx dx
                call   GetMcrStatus             ; f䃌WX^̓ǂݎ
                xor     ax,ax
                .if bl & DTR                    ; Bit 0 ̃`FbN
                    inc     ax
                .endif
                ret
CheckEr         endp

SetRsOn         proc   uses bx dx
                call   GetMcrStatus             ; f䃌WX^̓ǂݎ
                or     al, RTS                  ; Bit 1Iɂ܂
                out    dx, al                   ; f䃌WX^̐ݒ
                ret
SetRsOn         endp

SetRsOff        proc   uses bx dx
                call   GetMcrStatus             ; f䃌WX^̓ǂݎ
                and    al, not RTS              ; Bit 1Itɂ܂
                out    dx, al                   ; f䃌WX^̐ݒ
                ret
SetRsOff        endp

CheckRs         proc   uses bx dx
                call   GetMcrStatus             ; f䃌WX^̓ǂݎ
                xor     ax,ax
                .if bl & RTS                    ; Bit 1 ̃`FbN
                    inc     ax
                .endif
                ret
CheckRs         endp

;******************************************************************************
;*                                                                            *
;*          f䃌WX^݂̌̒l̓ǂݍ                            *
;*                                                                            *
;******************************************************************************
GetMcrStatus    proc   near private
                mov    dx, PortBase             ; I/O|[g̃x[XAhX
                                                ;   PortBase  rsdrv.inc 
                                                ;   O`Ă܂
                add    dx, 4                    ; f䃌WX^̃AhX
                in     al, dx                   ; ݂̃f󋵂̎擾
                mov    bl, al                   ; l̑Ҕ
                ret
GetMcrStatus    endp

;******************************************************************************
;*                                                                            *
;*          CD/CI/DR/CSM̏Ԃ̓ǂݍ                                   *
;*          void         ChackCd(void);    CDM̏Ԃ̎擾                 *
;*          void         ChackCi(void);    CIM̏Ԃ̎擾                 *
;*          void         ChackDr(void);    DRM̏Ԃ̎擾                 *
;*          void         ChackCs(void);    CSM̏Ԃ̎擾                 *
;*                                                                            *
;******************************************************************************
CheckCd         proc   uses bx dx
                call   GetMsrStatus             ; fXe[^XWX^̓ǂݎ
                xor     ax,ax
                .if bl & DCD                    ; Bit 7 ̃`FbN
                    inc     ax
                .endif
                ret
CheckCd         endp

CheckCi         proc   uses bx dx
                call   GetMsrStatus             ; fXe[^XWX^̓ǂݎ
                xor     ax,ax
                .if bl & RI                     ; Bit 6 ̃`FbN
                    inc     ax
                .endif
                ret
CheckCi         endp

CheckDr         proc   uses bx dx
                call   GetMsrStatus             ; fXe[^XWX^̓ǂݎ
                xor     ax,ax
                .if bl & DSR                    ; Bit 5 ̃`FbN
                    inc     ax
                .endif
                ret
CheckDr         endp

CheckCs         proc   uses bx dx
                call   GetMsrStatus             ; fXe[^XWX^̓ǂݎ
                xor     ax,ax
                .if bl & CTS                    ; Bit 4 ̃`FbN
                    inc     ax
                .endif
                ret
CheckCs         endp

;******************************************************************************
;*                                                                            *
;*          fXe[^XWX^݂̌̒l̓ǂݍ                      *
;*                                                                            *
;******************************************************************************
GetMsrStatus    proc   near private
                mov    dx, PortBase             ; I/O|[g̃x[XAhX
                                                ;   PortBase  rsdrv.inc 
                                                ;   O`Ă܂
                add    dx, 5                    ; fXe[^XWX^̃AhX
                in     al, dx                   ; ݂̃fXe[^X̎擾
                mov    bl, al                   ; l̑Ҕ
                ret
GetMsrStatus    endp

                end
