;****************************************************************************
;***																	  ***
;***		File Name         :  TEXTCTRL.ASM							  ***
;***		Description       :  Video Vram Absorute Control			  ***
;***																	  ***
;****************************************************************************

include			std.inc

                .code

;******************************************************************************
;*                                                                            *
;*          ̕\                                                      *
;*          void      PutStringAbs(x,y,str,atr);                              *
;*          p[^F x ,y  \JnW                                   *
;*                       str                                            *
;*                       atr   ʑ                                       *
;*          ߂lF     Ȃ                                                 *
;*                                                                            *
;******************************************************************************
PutStringAbs	proc	uses ds es si di, x:byte, y:byte, dstr:PBYTE, atr:byte
				assume	ds:@data
				if @model gt 3
				lds		si, dstr
				else
				mov		si, dstr
				endif
				xor		cx,cx
				.while byte ptr ds:[si] != 0
					inc		cx
					inc		si
				.endw
				.if cx != 0
					mov		bl, atr 			; \
					xor		bh,bh				; y[W
					mov		dl, x				; 
					mov		dh, y				; s
					sub		dx,101h				; sA̕␳
					if @model gt 3
					les		bp, dstr			; ̃AhX
					else
					mov		bp, dstr			; ̃AhX
					MOVSEG	es,ds
					endif
					VIDEO	1300h				; \(وړȂ)
				.endif
				ret
PutStringAbs	endp


;******************************************************************************
;*                                                                            *
;*          ̕\Q(zVRAMɏނ)                            *
;*          void      PutStringAbs2(x,y,str,atr,cnt);                         *
;*          p[^F x ,y  \JnW                                   *
;*                       str                                            *
;*                       atr   ʑ                                       *
;*                       cnt   \                                     *
;*          ߂lF     Ȃ                                                 *
;*                                                                            *
;******************************************************************************
PutStringAbs2	proc	uses ds es si di, x:word, y:word, dstr:PBYTE, atr:byte, cnt:word
				assume	ds:@data
				mov		ax, y					; s
				mov		bx, x					; 
				call	_CalcVramAddr			; zVRAMAhX̌vZ
				if @model gt 3
				lds		si, dstr				; ̐擪AhX
				else
				mov		si, dstr				; ̐擪AhX
				endif
				mov		ah, atr					; \
				mov		cx, cnt					; \
				.repeat
					lodsb						; ̕
					stosw						; Ƒ̏
				.untilcxz
				ret
PutStringAbs2	endp


;******************************************************************************
;*                                                                            *
;*          ̘A\                                                    *
;*          void      PutLoopChar(x,y,chr,atr,cnt);                           *
;*          p[^F x ,y  \JnW                                   *
;*                       chr   \镶                                   *
;*                       atr   ʑ                                       *
;*                       cnt   \                                     *
;*          ߂lF     Ȃ                                                 *
;*                                                                            *
;******************************************************************************
PutLoopChar		proc	uses bx cx es di, x:word, y:word, chr:byte ,atr:byte, cnt:word
				mov		ax, y					; s
				mov		bx, x					; 
				call	_CalcVramAddr			; zVRAMAhX̌vZ

				mov		ah, atr					; \
				mov		al, chr					; \
				mov		cx, cnt					; \

				PUSHM	<di,cx>
				rep		stosw
				POPM	<cx,di>

				VIDEO	0FFh					; Rewrite Screen
				ret
PutLoopChar		endp


				end
