#include	<stdio.h>

#include	"common.h"

int		BuzzWaitValue = 15 ;
uint	BuzzerCount ;

void	Buzzer(int BuzzWaitValue, uint BuzzerCount) ;

double	hz_tbl[] = {
			  65.41 ,  69.30 ,  73.42 ,  77.78 ,  82.41 ,  87.31 ,
			  92.50 ,  98.00 , 103.83 , 110.00 , 116.54 , 123.47 ,
			 130.81 , 138.59 , 146.83 , 155.06 , 164.81 , 174.61 ,
			 185.00 , 196.00 , 207.65 , 220.00 , 233.08 , 246.94 ,
			 261.63 , 277.18 , 293.66 , 311.13 , 329.63 , 349.23 ,
			 369.99 , 392.00 , 415.30 , 440.00 , 466.16 , 493.88 ,
			 523.25 , 554.37 , 587.33 , 622.25 , 659.26 , 698.46 ,
			 739.99 , 783.99 , 830.61 , 880.00 , 932.33 , 987.77 ,
			1046.50 ,1108.73 ,1174.66 ,1244.51 ,1328.51 ,1396.91 ,
			1479.98 ,1567.98 ,1661.22 ,1760.00 ,1864.66 ,1975.53 } ;
		/*      C        C#       D        D#       E        F        */
		/*      F#       G        G#       A        A#       B        */

main()
{

	int		i ;
	double	hz ;

	for ( i = 3 ; i < 53 ; i += 3 ) {
		BuzzerCount = (unsigned)( (double)1193180.0 / hz_tbl[i] ) ;
		printf("Buzzer [%7.2f Hz] = %5u\n",hz_tbl[i],BuzzerCount) ;
		if ( i > 50 )
			BuzzWaitValue = 75 ;
		Buzzer(BuzzWaitValue,BuzzerCount) ;
	}

	BuzzWaitValue = 15 ;
	for ( i = 52 ; i >= 3 ; i -= 3 ) {
		if ( i == 4 )
			hz = hz_tbl[i+4];
		else
			hz = hz_tbl[i];
		BuzzerCount = (unsigned)( (double)1193180.0 / hz ) ;
		printf("Buzzer [%7.2f Hz] = %5u\n",hz,BuzzerCount) ;
		if ( i < 6 )
			BuzzWaitValue = 75 ;
		Buzzer(BuzzWaitValue,BuzzerCount) ;
	}
	BuzzerCount = (unsigned)( (double)1193180.0 / hz_tbl[36] ) ;
	BuzzWaitValue = 0;
	Buzzer(BuzzWaitValue,BuzzerCount) ;

}
