;****************************************************************************
;***																	  ***
;***		File Name         :  REALTIME.ASM							  ***
;***		Description       :  A^C荞݊֘A				  ***
;***																	  ***
;****************************************************************************

include			std.inc


CTL8259         equ     20h                     ; }X^[8259A |[g
DTA8259         equ     02h                     ; }X^[8259A f[^|[g
CTL8253         equ     43h                     ; 8253|[g
DTA82530        equ     40h                     ; 8253f[^|[g 0
TIMER_MASK      equ     01h                     ; }X^[IRQ0 荞݃}XN
EOI             equ     20h                     ; 

                .data
                extrn   ltick:dword

                .code

;******************************************************************************
;*                                                                            *
;*          ^C}[荞݃nh[̐ݒ                                  *
;*          void        StartRealTime(uint cycle);                            *
;*          p[^Fcycle                                             *
;*          ߂lF    Ȃ                                                  *
;*                                                                            *
;******************************************************************************
OrgRealTimeHandler  dword   ?

StartRealTime   proc    uses bx cx dx ds es, cycle:word
                cli                             ; 荞݋֎~
                in      al, DTA8259
                or      al, TIMER_MASK
                out     DTA8259, al             ; ^C}[荞݃}XNZbg
                sti                             ; 荞݉

                MSDOS   3508h                   ; Õnh[AhX̕ۑ
                mov     word ptr cs:OrgRealTimeHandler+2, es
                mov     word ptr cs:OrgRealTimeHandler, bx
                MOVSEG  ds, cs
                mov     dx,offset cs:RealTimeHandler
                MSDOS   2508h                   ; Vnh[EAhX

                mov     al, 36h                 ; `g([h3)
                out     CTL8253, al
                mov     cx, cycle               ; 
                mov     cs:ncount, cl           ; ̕ۑ
                xor     ax, ax
                mov     cs:counter, al          ; JE^[̏
                mov     dx, 1
                div     cx
                out     DTA82530, al
                mov     al, ah
                out     DTA82530, al            ; JE^[Ɋ荞ݎZbg

                cli                             ; 荞݋֎~
                in      al, DTA8259
                and     al, not TIMER_MASK
                out     DTA8259, al             ; ^C}[荞݃}XN
                sti                             ; 荞݉
                ret
StartRealTime   endp

;******************************************************************************
;*                                                                            *
;*          ^C}[荞݃nh[̉                                  *
;*          int         StopRealTime(void);                                   *
;*          ߂lF    0     : łȂ                                  *
;*                      0ȊO : ł                                    *
;*                                                                            *
;******************************************************************************
StopRealTime    proc    uses dx ds
                cli                             ; 荞݋֎~
                in      al, DTA8259
                or      al, TIMER_MASK
                out     DTA8259, al             ; ^C}[荞݃}XNZbg
                sti                             ; 荞݉

                lds     dx, cs:OrgRealTimeHandler  ; ̃nh[AhX
                .if dx != 0                     ; ̃AhXOłȂ
                    MSDOS   2508h               ; AhXɖ߂
                .else
                    xor     ax, ax              ; ̃AhXO̎
                .endif

                mov     al, 36h                 ; `g([h3)
                out     CTL8253, al
                xor     ax, ax                  ; ̕
                out     DTA82530, al
                mov     al, ah
                out     DTA82530, al            ; JE^[̒lɖ߂

                mov     word ptr cs:OrgRealTimeHandler+2, ax
                mov     word ptr cs:OrgRealTimeHandler, ax

                cli                             ; 荞݋֎~
                in      al, DTA8259
                and     al, not TIMER_MASK
                out     DTA8259, al             ; ^C}[荞݃}XN
                sti                             ; 荞݉
                ret
StopRealTime    endp

;******************************************************************************
;*                                                                            *
;*          ^C}[荞݃nh[(֐)                              *
;*                                                                            *
;******************************************************************************
ncount              db      ?                   ; 
counter             db      ?

RealTimeHandler     proc    private
                    pushf
                    push    ax

                    push    ds
                    mov     ax,@data
                    mov     ds, ax
					assume	ds:@data
                    add     word ptr ltick, 1
                    adc     word ptr ltick+2, 0
                    pop     ds

                    inc     cs:counter          ; 荞݉񐔃JEgAbv
                    mov     al, cs:counter
                    .if al == cs:ncount         ; Nڂ̎
                        xor     al, al
                        mov     cs:counter, al  ; JE^[̏
                        pop     ax              ; WX^[̕A
                        popf
                        jmp     cs:OrgRealTimehandler
                                                ; ̊荞݃nh[Ăяo
                    .endif
                                                ; NڈȊO̎
                    cli                         ; 荞݂֎~
                    mov     al, EOI
                    out     CTL8259, al         ; 8259A  EOI ]
                    pop     ax
                    popf
                    iret
RealTimeHandler     endp


                    end
